Loading...
Searching...
No Matches
Opm::BrooksCorey< TraitsT, ParamsT > Class Template Reference

Implementation of the Brooks-Corey capillary pressure <-> saturation relation. More...

`#include <BrooksCorey.hpp>`

Inheritance diagram for Opm::BrooksCorey< TraitsT, ParamsT >:

## Public Types

typedef TraitsT | Traits
typedef ParamsT | Params
typedef Traits::Scalar | Scalar

## Static Public Member Functions

template<class Container, class FluidState>
static void | capillaryPressures (Container &values, const Params &params, const FluidState &fs)
| The capillary pressure-saturation curves.
template<class Container, class FluidState>
static void | saturations (Container &values, const Params &params, const FluidState &fs)
| Calculate the saturations of the phases starting from their pressure differences.
template<class Container, class FluidState>
static void | relativePermeabilities (Container &values, const Params &params, const FluidState &fs)
| The relative permeability-saturation curves.
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | pcnw (const Params &params, const FluidState &fs)
| The capillary pressure-saturation curve according to Brooks and Corey.
template<class Evaluation>
static Evaluation | twoPhaseSatPcnw (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatPcnwInv (const Params &params, const Evaluation &pcnw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | Sw (const Params &params, const FluidState &fs)
| The saturation-capillary pressure curve according to Brooks & Corey.
template<class Evaluation>
static Evaluation | twoPhaseSatSw (const Params &params, const Evaluation &pc)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | Sn (const Params &params, const FluidState &fs)
| Calculate the non-wetting phase saturations depending on the phase pressures.
template<class Evaluation>
static Evaluation | twoPhaseSatSn (const Params &params, const Evaluation &pc)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | krw (const Params &params, const FluidState &fs)
| The relative permeability for the wetting phase of the medium implied by the Brooks-Corey parameterization.
template<class Evaluation>
static Evaluation | twoPhaseSatKrw (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatKrwInv (const Params &params, const Evaluation &krw)
template<class FluidState, class Evaluation = typename FluidState::Scalar>
static Evaluation | krn (const Params &params, const FluidState &fs)
| The relative permeability for the non-wetting phase of the medium as implied by the Brooks-Corey parameterization.
template<class Evaluation>
static Evaluation | twoPhaseSatKrn (const Params &params, const Evaluation &Sw)
template<class Evaluation>
static Evaluation | twoPhaseSatKrnInv (const Params &params, const Evaluation &krn)

## Static Public Attributes

static const int | numPhases = Traits::numPhases
| The number of fluid phases to which this material law applies.
static const bool | implementsTwoPhaseApi = true
| Specify whether this material law implements the two-phase convenience API.
static const bool | implementsTwoPhaseSatApi = true
| Specify whether this material law implements the two-phase convenience API which only depends on the phase saturations.
static const bool | isSaturationDependent = true
| Specify whether the quantities defined by this material law are saturation dependent.
static const bool | isPressureDependent = false
| Specify whether the quantities defined by this material law are dependent on the absolute pressure.
static const bool | isTemperatureDependent = false
| Specify whether the quantities defined by this material law are temperature dependent.
static const bool | isCompositionDependent = false
| Specify whether the quantities defined by this material law are dependent on the phase composition.

## Detailed Description

template<class TraitsT, class ParamsT = BrooksCoreyParams<TraitsT>>
class Opm::BrooksCorey< TraitsT, ParamsT >

Implementation of the Brooks-Corey capillary pressure <-> saturation relation.

This class provides the "raw" curves as static members and doesn't concern itself converting absolute to effective saturations and vice versa.

See also
  BrooksCoreyParams

## Member Function Documentation

## krn()

template<class TraitsT, class ParamsT = BrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::BrooksCorey< TraitsT, ParamsT >::krn | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

The relative permeability for the non-wetting phase of the medium as implied by the Brooks-Corey parameterization.

Parameters

  params | The parameters of the capillary pressure curve (for Brooks-Corey: Entry pressure and shape factor)
  fs | Fluid state

## krw()

template<class TraitsT, class ParamsT = BrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::BrooksCorey< TraitsT, ParamsT >::krw | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

The relative permeability for the wetting phase of the medium implied by the Brooks-Corey parameterization.

Parameters

  params | The parameters of the capillary pressure curve (for Brooks-Corey: Entry pressure and shape factor)
  fs | Fluid state

## pcnw()

template<class TraitsT, class ParamsT = BrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::BrooksCorey< TraitsT, ParamsT >::pcnw | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

The capillary pressure-saturation curve according to Brooks and Corey.

The empirical Brooks-Corey capillary pressure-saturation function is defined as

Parameters

  params | The parameters of the capillary pressure curve (for Brooks-Corey: Entry pressure and shape factor)
  fs | Fluid state

## relativePermeabilities()

template<class TraitsT, class ParamsT = BrooksCoreyParams<TraitsT>>
template<class Container, class FluidState>

void Opm::BrooksCorey< TraitsT, ParamsT >::relativePermeabilities | ( | Container & | values,
|  | const Params & | params,
|  | const FluidState & | fs )

inline static

The relative permeability-saturation curves.

Parameters

  values | A random access container which stores the relative permeability of each fluid phase.
  params | The parameter object expressing the coefficients required by the material law.
  fs | The fluid state for which the relative permeabilities ought to be calculated

## Sw()

template<class TraitsT, class ParamsT = BrooksCoreyParams<TraitsT>>
template<class FluidState, class Evaluation = typename FluidState::Scalar>

Evaluation Opm::BrooksCorey< TraitsT, ParamsT >::Sw | ( | const Params & | params,
|  | const FluidState & | fs )

inline static

The saturation-capillary pressure curve according to Brooks & Corey.

This is the inverse of the capillary pressure-saturation curve:

Parameters

  params | The parameters of the capillary pressure curve (for Brooks-Corey: Entry pressure and shape factor)
  fs | Fluid state

The documentation for this class was generated from the following file:

- opm/material/fluidmatrixinteractions/BrooksCorey.hpp